Sliding Window

Very common Leetcode problem.

Sliding Window with CNN

This technique alongs to do do convolution much more efficiently, see Convolutional Implementation Sliding Windows

So essentially, with the sliding window approach, say you want to do Object Detection on a 16x16x3 image.

You train your CNN on a 14x14x3 image, and you simply slide the image 4 times with strides of 2 pixels (top left, top right, bottom left, bottom right).

However, you realize that the computations are highlight redundant, because there are overlap. So instead of doing 4 passes (forward propagation 4 times) to do one detection, you can share these and do it in ONE SINGLE PASS.

You do this by treating a Fully Connected Layer as a convolution.